-- Copyright (C) 2020  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "11/04/2022 12:29:04"
                                                            
-- Vhdl Test Bench template for design  :  Dec_hex_7seg
-- 
-- Simulation tool : ModelSim-Altera (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY Dec_hex_7seg_vhd_tst IS
END Dec_hex_7seg_vhd_tst;


ARCHITECTURE Dec_hex_7seg_arch OF Dec_hex_7seg_vhd_tst IS
-- constants                                                 
-- signals                                                   
SIGNAL BI_L : STD_LOGIC;
SIGNAL D : STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL LT_L : STD_LOGIC;
SIGNAL RBI_L : STD_LOGIC;
SIGNAL RBO_L : STD_LOGIC;
SIGNAL Y_L : STD_LOGIC_VECTOR(6 DOWNTO 0);


COMPONENT Dec_hex_7seg
	PORT (
	BI_L : IN STD_LOGIC;
	D : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
	LT_L : IN STD_LOGIC;
	RBI_L : IN STD_LOGIC;
	RBO_L : OUT STD_LOGIC;
	Y_L : OUT STD_LOGIC_VECTOR(6 DOWNTO 0)
	);
END COMPONENT;
   -- No clocks detected in port list. Replace <clock> below with 
   -- appropriate port name 
 
   constant Min_Pulse : time := 10 us;
-- run for 600 us

BEGIN
	i1 : Dec_hex_7seg
	PORT MAP (
-- list connections between master ports and signals
	BI_L => BI_L,
	D => D,
	LT_L => LT_L,
	RBI_L => RBI_L,
	RBO_L => RBO_L,
	Y_L => Y_L
	);



   -- Stimulus process
   stim_proc: process
   begin		
      -- Circuit initialisation period (do nothing). 
      wait for 100 ns;	
      wait for Min_Pulse*7.5; 

-- Let's start the stimulus activity 
		D <= "0110";
		BI_L  <= '1';
		LT_L  <= '1';
		RBI_L <= '1';		
		wait for Min_Pulse*3.2;
	  
-- Normal decoding 
		D <= "1011"; -- B
		wait for Min_Pulse*1.15;	
		
		D <= "1001";  -- 9
		wait for Min_Pulse*1.15;	

		D <= "0000"; --- 0
		wait for Min_Pulse*1.15;	

		D <= "1110"; --- E
		wait for Min_Pulse*1.15;	

-- Testing blanking (display OFF)

		BI_L <= '0';
		wait for Min_Pulse*4.15;	

		BI_L <= '1';
		wait for Min_Pulse*2.15;	

-- Testing lamp test (all LED ON)

		LT_L <= '0';
		wait for Min_Pulse*4.15;	

		LT_L <= '1';
		wait for Min_Pulse*2.15;	

-- Testing ripple blanking input (OFF when D = 0)

		RBI_L <= '0';
		wait for Min_Pulse*4.15;	

		D <= "0000";  -- 0 --> Now to must blank (all '1')
		wait for Min_Pulse*4.33;
		
		D <= "0111";  -- 7 
		wait for Min_Pulse*4.33;		
		
		RBI_L <= '1';
		wait for Min_Pulse*2.15;	

-- Resuming normal decoding
		D <= "1101";  -- C
		wait for Min_Pulse*1.15;	

		D <= "0001"; --- 1
		wait for Min_Pulse*1.15;	

		D <= "0000"; --- 0
		wait for Min_Pulse*1.15;	
		
      wait;
   end process;

END Dec_hex_7seg_arch;
